=== debian/changelog ===
pistache (0.0.002) eoan; urgency=medium

  * Latest upstream.

 -- Kip Warner <kip@thevertigo.com>  Fri, 17 Jan 2020 14:29:59 -0800
